var pow_serv = null;
var random_cookie = "";
// PUBLIC API //

/**
 *
 * Adds header lines, or replaces them, in Content-Type's case
 *
 */

function pow_header(line) {
	try {
		if(line.match(/Content-Type: +(.+)/)) {
			var m = line.match(/Content-Type: +(.+)/);
			pow_response.content_type = m[1];
		} else if(line.match(/Location: +(.+)/)) {
			pow_response.status_code = "302 Moved";
			pow_response.extra_headers += line+"\n";
		} else {
			pow_response.extra_headers += line+"\n";
		}
	} catch(e) {
		log_error(e);
		return "";
	}
}

/**
 *
 * Stops printing to the client. Script continues, anyway.
 * Unreliable, but workaround my have to throw an exception.
 *
 */

function pow_exit() {
	throw("exit_flag");
}

/**
 *
 * Allows the debug interface to operator from the local machine only
 * This exports all SJS calls as client side JS and opens the ajax interface.
 *
 */

function pow_debug() {
	// Should also check login is required
	if(pow_server.REMOTE_HOST == "127.0.0.1") {
		throw("debug_flag");
	}
}

/**
 *
 * Exits the code up to that point and highlights the source code.
 * Only works with localhost for security reasons
 *
 */

function pow_highlight() {
	if(pow_server.REMOTE_HOST == "127.0.0.1") {
		throw("highlight_flag");
	}
}

// END PUBLIC API //

 /**
	* 
	* This is the basis for document, which is invoked for writeln()
	* 
	*/

function pow_Document() {
	this.writeln = function(line) {
		line = line.replace(/\$/,"__DOLLAR__");
		pow_response.script_out += line+"\n";
	}
	this.write = function(line) {
		line = line.replace(/\$/,"__DOLLAR__");
		pow_response.script_out += line;
	}
}

/**
	* 
	* Turns array to string for pow_info() 
	* 
	*/

function pow_array_tostring(arr) {
	var joined = new Array();
	for (var i in arr) {
	  joined.push(i+": "+arr[i]);
	}
	return joined.join(", ");
}

/**
	* 
	* Returns client side version of server code
	* Uses AJAX interface to communicate 
	* 
	*/

function pow_create_client_code(code) {
  var reg1 = new RegExp("<"+"\\?"+"sjs","gm");
  code = code.replace(reg1, "<script>");
  var reg2 = new RegExp("\\?"+">","gm");
  code = code.replace(reg2, "</script>");
	var env = "";
	env += "var pow_server = new pow_Serv();\n";
	env += "pow_server.REMOTE_HOST = '"+pow_server.REMOTE_HOST+"';\n";
	if(pow_server.POST_FILENAME) {
		env += "pow_server.POST_FILENAME = '"+pow_server.POST_FILENAME+"';\n";
	}
	/* POST */
	for( var i in pow_server.POST) {
		if(i) {
			env += "pow_server.POST['"+i+"'] = '"+pow_server.POST[i]+"';\n";
		}
	}
	/* REQUEST */
	for( var i in pow_server.REQUEST) {
		if(i) { env += "pow_server.REQUEST['"+i+"'] = '"+pow_server.REQUEST[i]+"';\n"; }
	}
	/* GET */
	for( var i in pow_server.GET) {
		if(i) { env += "pow_server.GET['"+i+"'] = '"+pow_server.GET[i]+"';\n"; }
	}
	/* REQUEST_HEADERS */
	for( var i in pow_server.REQUEST_HEADERS) {
		if(i) { env += "pow_server.REQUEST_HEADERS['"+i+"'] = '"+pow_server.REQUEST_HEADERS[i]+"';\n"; }
	}
			var raw_post = pow_server.RAW_POST;
			raw_post = raw_post.replace(/\n/mg,"\\n");
			raw_post = raw_post.replace(/\r/mg,"\\r");
			raw_post = raw_post.replace(/"/mg,"\\\""); //"
			env += "pow_server.RAW_POST = \""+raw_post+"\";\n";
			var raw_request = pow_server.RAW_REQUEST;
			raw_request = raw_request.replace(/\n/mg,"\\n");
			raw_request = raw_request.replace(/\r/mg,"\\r");
			raw_request = raw_request.replace(/"/mg,"\\\""); //"
			env += "pow_server.RAW_REQUEST = \""+raw_request+"\";\n";
			if(pow_server.POST_FILENAME) {
				env += "pow_server.POST_FILENAME = '"+pow_server.POST_FILENAME+"';\n";
			}
	
	code = code.replace(/pow_debug\([^\(\)]*\);/, "var pow_debug_on=true;</script><script src='/system/rpc.js'></script><script>\n"+env);
	return code;
}

/**
	* 
	* Returns highlighted text
	* 
	*/

function pow_highlight_code(code) {
  code = code.replace(/<([^\?][^<>]*)>/gm, "<font color='green'>&lt;$1&gt;</font>");
  var reg1 = new RegExp("<"+"\\?"+"sjs","gm");
  code = code.replace(reg1, "<font color='red'>&lt;?sjs</font>");
  var reg2 = new RegExp("\\?"+">","gm");
  code = code.replace(reg2, "<font color='red'>?&gt;</font>");
  var hiwords = new Array("pow_include", "document.write(ln)?","pow_highlight");
  for(var i in hiwords) {
    var reg = new RegExp("("+hiwords[i]+")","gm");
    code = code.replace(reg, "<font color='blue'>$1</font>");
  }
  code = code.replace(/"([^"]+)"/g,"\"<font color='gray'>$1</font>\""); //"
  code = code.replace(/;\n/gm, ";<br/>\n");
	return code;
}


/**
	* 
	* Server that can be instantiated. How long until httpd.js catches up? 
	* 
	*/

function pow_Serv() {
	this.query_pairs = new Array();
	this.pairs = new Array();
	this.whole_get = "";
	this.root_directory = pow_bc_get_root_directory();
	this.index_directory = pow_bc_get_index_directory();
	this.content_type = "text/html";
	this.response_code = "200 OK";
	// PUBLIC
	this.REQUEST = new Array();
	this.GET =  new Array();
	this.POST =  new Array();
	this.REWRITE_RULES =  new Array();
	this.REQUEST_HEADERS =  new Array();
	this.RAW_POST = "";
	this.RAW_REQUEST = "";
	this.REMOTE_HOST = "";
	this.POST_FILENAME = "";
	// END PUBLIC
	this.serv = null;
	this.crontab_on = false;
	this.default_webpage = 
	"\r\n<html>\n<head>\n<title>400 Bad Request</title>\n</head>\n"  +
	"<body>\n<h1>Bad Request</h1>\n" +
	"Invalid URI\n" +
	"</body>\n</html>\n";
	pow_response.script_out = "";
	pow_response.exit_flag = false;
	pow_response.highlight_flag = false;
	pow_response.debug_flag = false;
	pow_response.extra_headers = "";

	// PUBLIC

	/**
    * 
    * Returns uploaded file using POST_FILE var 
    * 
	  */
	this.get_uploaded_file = function() {
		if(!this.POST_FILE) {
			return "";
		} else {
			return this.POST_FILE;
		}
	}
	// END PUBLIC
	this.async_listener = new Async(this);

	/**
    * 
    * Finds <?sjs ?> sections quickly and evals them 
    * 
	  */
	this.process_server_js = function(webpage) {
		try {
			var raw_webpage = webpage;
			webpage = (function(webpage) {
			var document = new pow_Document();
			var m = webpage.match(/Content-Location: (.*)/m);
			var content_location = m[1];
			webpage = webpage.replace(/\?/g,"__QUEST__");
			webpage = webpage.replace(/<__QUEST__sjs/g,"<?sjs");
			webpage = webpage.replace(/__QUEST__>/g,"?>");

			var lost_lines = 0;
			if(webpage.indexOf("?") == -1 ) {
				m = false;
			} else {
				m = webpage.match(/([^\?]*)<\?sjs(([^\?]|\n)*)\?>/m);
			}
			var function_offset = 0;
			try {
				throw_error(); // dummy function to find line number
			} catch(e) {
				function_offset = e.lineNumber + 14;
			}

			// 2-3 too long
			while(m && pow_response.exit_flag == false) {
				var num_rets = m[1].split(/\n/);
				var offset = num_rets.length + lost_lines;
				var script = m[2];
				script = script.replace(/__QUEST__/g,"?");
				try {
					eval(script);
				} catch (e if e == "exit_flag") {
					pow_response.exit_flag = true;
				} catch (e if e == "highlight_flag") {
					pow_response.exit_flag = true;
					pow_response.highlight_flag = true;
				} catch (e if e == "debug_flag") {
					pow_response.exit_flag = true;
					pow_response.debug_flag = true;
				} catch (e) {
					e.lineNumber -=  function_offset - offset+1;
					document.write('Error: '+pow_request.req_file+':'+
							e.lineNumber+' '+e.message);
				}

				var before_length = webpage.split(/\n/).length;
				var webpage = webpage.replace( /<\?sjs(([^\?]|\n)*)\?>/m, 
						pow_response.script_out );
				webpage = webpage.replace(/__DOLLAR__/,"$");
				lost_lines += before_length - webpage.split(/\n/).length;
				pow_response.script_out = "";
				if(webpage.indexOf("<?sjs") == -1 ) {
					m = false;
				} else {
					m = webpage.match(/([^\?]*)<\?sjs(([^\?]|\n)*)\?>/m);
				}
			}
			webpage = webpage.replace(/__QUEST__/g,"?");
			webpage = webpage.replace(/Content-Length: \d+\r\n/m,"");
			return webpage;
			})(webpage);
			if(pow_response.highlight_flag) {
				webpage = pow_highlight_code(raw_webpage);
			} else if(pow_response.debug_flag) {
				webpage = pow_create_client_code(raw_webpage);
			}
			return webpage;
		} catch(e) {
			log_error(e); return "";
		}
	};

	/**
    * 
    * Applies REWRITE rules, similar to .htaccess rewrite rules 
    * 
	  */

	this.rewrite_request = function(data_in) {
		var request_match = data_in.match(/(GET|POST) *(\/[^ ?]*\??[^ ]*)/);
		if(!request_match) { return data_in; }
		var url = request_match[2];
		if(this.REWRITE_RULES) {
			for(var i in this.REWRITE_RULES) {
				var rule_pair = this.REWRITE_RULES[i];
				if(rule_pair[0] && rule_pair[1]) {
					var re = new RegExp(rule_pair[0]);
					url = url.replace(re, rule_pair[1]);
					data_in = data_in.replace(/(GET|POST) *(\/[^ ?]*\??[^ ]*)/,"$1 "+url);
				}
			}
		}
		return data_in;
	};

	/**
    * 
    * Returns login form 
    * 
	  */

	this.get_login_form = function( last_url ) {
		try {
			var form = "<html><head><title>Breadcrumbs Login</title></head><body>\n";
			form += "<script language='javascript' src='/md5.js'> </script>\n";
			form += "<script>var salt='1234';</script>\n";
			form += "<h2><center>POW Login</center></h2>";
			form += "<form action='"+last_url+"'"+
 	       " name='login' onsubmit=\"e = "+
 	         "forms['login'].elements['password'];"+
 	       "e.value=hex_md5(e.value+salt);\" method='POST'>\n";
			form += "<br/><br/>\n<table>";
			form += "<tr><td>User ID: </td><td> <input id='user' "+
					"type='text' name='userid'  "+
					"size='20' /></td></tr>\n";
			form += "<tr><td>Password: </td><td><input type='password' "+
					"name='password'  "+
					"size='20' /></td></tr>\n";
			form += "<tr><td><input type='submit' value='Login' /></td></tr>\n";
			form += "\n</table>\n";
			form += "</form><br/>\n";
			form += "</body></html>";
			return form;
		} catch(e) {
			log_error(e); return "";
		}
	}

	/**
    * 
    * Returns links for the top of the default pages
    * 
	  */

	this.get_links = function() {
		var links = "<a href='/'>Home</a> <a href='/search.sjs'>Search</a> "+
				"<a href='/help.sjs'>FAQ</a> <a href='http://davidkellogg.com/wiki/Main_Page'>Help</a>";
		if(this.REMOTE_HOST != "127.0.0.1") {
			links += "<script>var hostname = location.hostname; var cook = document.cookie; cook = cook.replace(/.*bc_id2=/,''); cook=cook.replace(/;.* ?/,''); document.write(\"<a href='http://localhost:"+pow_global_port + "/addip.sjs?ip=\"+hostname+\"&cookie=\"+cook+\"'>Add This Search</a>\");</script> ";
			links += 
				"<a href='http://addons.mozilla.org/firefox/2954/'>Get Breadcrumbs</a>";
		} else {
			var unique_userid = pow_bc_get_unique_userid();
			links +=
				"<a href='http://davidkellogg.com/infinilink/"+unique_userid+"/'>Infinilink</a>";

		}
		links += "<br/>\n";
		return links;
	}

	/**
    * 
    * Returns validity of password, given salt and userid
    * 
	  */

	this.auto_login_valid = function(pass, salt, userid) {
		try {
			var correct_pass = hex_md5(pow_bc_get_unique_password()+userid);
			var obfusc_pass = hex_md5(correct_pass+salt);
			if(obfusc_pass && obfusc_pass == pass) {
				if(! is_authorized(userid, this.REMOTE_HOST)) {
					return false;
				}
				return true;
			} else {
				return false;
			}
		} catch(e) {
			log_error(e); return "";
		}
	}

	/**
    * 
    * Takes in title and javascript.
		* Returns header for pow page.
    * 
	  */

	this.get_header = function(title, onload_function) {
		try {
			if( !onload_function ) {
				onload_function = 'return true';
			}
			var header = "<html>\n<head>\n<title>"+title;
			header += "</title>\n<link rel='stylesheet' href='pow.css' "+
					"type='text/css'>\n</head>\n"+
					"<meta http-equiv=\"Content-Type\" content=\"text/html; "+
					"charset=utf-8\">\n"+
					"<body onload='"+onload_function+"'>\n";
			header += this.get_links();
			return  header;
		} catch(e) {
			log_error(e); return "";
		}
	}

	/**
    * 
		* Returns standard pow footer
    * 
	  */

	this.get_footer = function() {
		return "\n</body>\n</html>";
	}

	/**
    * 
		* Returns breadcrumbs search form.
    * 
	  */

	this.get_form = function( query ) {
		try {
			if(query) {
				query = query.replace(/\+/g, " ");
			} else {
				query = '';
			}
			var form = "<form method='GET' action='/search.sjs'>\n";
			form += '<input id="search" type="text" name="query" value="'+
					query+'" size=20 />\n';
			form += "<input type='submit' value='Search' />\n";
			form += "</form><br>";
			return form;
		} catch(e) {
			log_error(e); return "";
		}
	}

	this.mime_pref = "";
	this.mimes = new Array();
	this.is_binary = Array();

	this.get_is_binary = function() {
		try {
			if(! this.is_binary) {
				this.is_binary = this.get_mime_types();
			}
			return this.is_binary;
		} catch(e) {
			log_error(e); return "";
		}
	}

	/**
    * 
		* Getter for request's query pairs.
    * 
	  */

	this.get_query_pairs = function() {
		return this.query_pairs;
	}

	/**
    * 
		* Getter for entire requested URI, with query string
    * whole_get is http://localhost/q?query=hello
    * 
	  */

	this.get_whole_get = function() {
		return this.whole_get;
	}

	this.get_req_file = function() {
		return pow_request.req_file;
	}

	this.get_req_dir = function() {
		return pow_request.req_dir;
	}

	this.get_pairs = function() {
		return this.pairs;
	}

	this.parse_post_request = function( data_in ) {
		try {
		this.query_pairs = new Array();
		var m = data_in.match(/POST *(\/[^ ?]*)\??([^ ]*)/);
		if(m) {
			// FIRST GET
			this.whole_get = m[1]+"?"+m[2];
			pow_request.req_file = m[1];
			pow_request.req_dir = pow_request.req_file.replace(/\/[^\/]*$/,"");
			this.query_pairs = m[2].split("&");
			//m = data_in.match(/\r\n\s*((.|\n|\r)*)/m);
			m = data_in.match(/\r\n\r\n\s*((.|\n|\r)*)/m);
			if(m) {
				this.RAW_POST = data_in;
				var raw_post = data_in;
				var delimiter = raw_post.match(/(-------.*)/);
				var post_file = raw_post.match(/filename="([^\"]*)"/);
				if(post_file) {
					this.POST_FILENAME = post_file[1];
				}
				var reg = new RegExp("Content-Type:[ a-zA-Z/\\-]*\r\n((.|\r|\n)*)");
				var body = raw_post.match(reg);
				if(body && delimiter) {
					var post_file = body[1];
					this.POST_FILE = post_file.replace("--"+delimiter[1]+"--", "");
				}
				var post_vars = m[1].split("&");
				this.GET = this.parse_pairs(this.query_pairs);
				this.query_pairs = this.query_pairs.concat(post_vars);
			}
		}
		this.pairs = this.parse_pairs(this.query_pairs);
		this.POST = this.pairs;
		this.REQUEST = this.pairs;
		} catch(e) {
			log_error(e); return "";
		}
	}

	this.get_request_array = function(data_in) {
		var request_headers = new Array();
	 	var raws = data_in.split(/\n/);
 	 	for(var i in raws) {
 	   	var tokens_match = raws[i].match(/^([^:]*): *(.*)/);
 	   	if(tokens_match && tokens_match[1] && tokens_match[2]) {
 	    	request_headers[tokens_match[1]] = tokens_match[2];
 	    	request_headers[tokens_match[1].toLowerCase()] = tokens_match[2];
 	   	}
 	 	}
		return request_headers;
	}

	this.parse_get_request = function( data_in ) {
		try {
		this.query_pairs = new Array();
		var m = data_in.match(/(GET|HEAD) *(\/[^ ?]*)\??([^ ]*)/);
		if( m ) {
			var has_query = data_in.match(/(GET|HEAD) *(\/[^ ?]*)\?([^ ]+)/);
			if(has_query) {
				this.whole_get = has_query[2]+"?"+has_query[3];
				pow_request.req_file = has_query[2];
				this.query_pairs = has_query[3].split("&");
			} else {
				this.whole_get = m[2];
				pow_request.req_file = m[2];
			}
			pow_request.req_dir = pow_request.req_file.replace(/\/[^\/]*$/,"");
		}
		this.pairs = this.parse_pairs(this.query_pairs);
		} catch(e) {
			log_error(e); return "";
		}
	};

	this.parse_pairs = function( query_pairs ) {
		try {
		var pairs = new Array();
		if(query_pairs) {
			for (var i=0; i < query_pairs.length; i++) {
				var query_pair = query_pairs[i].split("=");
				pairs[ query_pair[0] ] = query_pair[1];
			} // END FOR i
		}
		return pairs;
		} catch(e) {
			log_error(e); return "";
		}
	};

	this.get_pow_mime_types = function() {
		try {
			this.mime_pref =  pow_bc_get_breadcrumbs_mime_list();
			if(! this.mime_pref) {
				this.mime_pref =  pow_get_default_mimes();
			}
			var mime_types = this.mime_pref.split(",");
			this.mimes = new Array();
			this.is_binary = new Array();
			var binary = false;
			for( var i=0;i<mime_types.length;i+=3  ) {
				this.mimes[mime_types[i]] = mime_types[i+1];
				if( mime_types[i+2] == "false" ) {

					this.is_binary[mime_types[i]] = false;
				} else {
					this.is_binary[mime_types[i]] = true;
				}
			}
			return this.mimes;
		} catch(e) {
			log_error(e); return "";
		}
	};

	this.get_mime_types = function() {
		try {
		this.mime_pref = pow_get_mimelist_pref();
		var mime_types = this.mime_pref.split(",");
		this.mimes = new Array();
		this.is_binary = new Array();
		var binary = false;
		for( var i=0;i<mime_types.length;i+=3  ) {
			this.mimes[mime_types[i]] = mime_types[i+1];
			this.is_binary[mime_types[i]] = mime_types[i+2];
		}
		} catch (e) {
			// noop
		}
		return this.mimes;
	}

	this.highlight_words = function( webpage, found_words ) {
		try {
			var head_body = webpage.split(/<\/head>/);
			var body = head_body[1];
			var found_words = found_words.split("+");
			for( i in found_words ) {
				var bold_point = RegExp("\\b("+found_words[i]+")\\b", "img");
				var hash_point = RegExp(
					"(__BOLD__)("+found_words[i]+")(__ENDBOLD__)", "im");
				var wrong_bold = RegExp("(<[^<>]*)__(END)?BOLD__([^<>]*>)", "mg");
				body = body.replace( bold_point, "__BOLD__$1__ENDBOLD__" );
				for(var j=0; j < 10 && body.match(wrong_bold); j++) {
					body=body.replace( wrong_bold, "$1$3" );
				}
				body = body.replace( hash_point, 
						"<a href='#"+found_words[i]+
						"' name='"+found_words[i]+"'></a>$1$2$3" );
				body = body.replace( /__BOLD__/mg,
						"<b style='color:black;background-color:#a0ffff'>" );
				body = body.replace( /__ENDBOLD__/mg,"</b>" );
			}
			webpage = head_body[0]+"</head>"+body;
			return webpage;
		} catch(e) {
			log_error(e); return "";
		}
	}

	this.start_server = function() {
		try {
			pow_global_port = pow_bc_get_port_number();
			random_cookie = pow_bc_get_auth_cookie();
			var unique_userid = pow_bc_get_unique_userid();
			if(! random_cookie ) {
				random_cookie = pow_bc_get_random_number();
				pow_bc_set_auth_cookie(random_cookie);
			}
			var loopback_only = pow_bc_get_loopback_only();
			var sock = Components.classes["@mozilla.org/network/server-socket;1"];
			pow_serv = sock.createInstance();
			pow_serv = pow_serv.QueryInterface(Components.interfaces.nsIServerSocket);
			pow_serv.init(pow_global_port,loopback_only,-1);
			pow_serv.asyncListen(this.async_listener);
			this.serv = pow_serv;
			window.addEventListener('unload', this.stop_server, false);
			if(pow_file_exists("/pow/htdocs/system/startup.sjs")) {
				pow_include("/pow/htdocs/system/startup.sjs");
			}
		} catch (e) {
			var s = e.toString();
			if (s.match(/80004005/)) {
				// IN THIS CASE,  a server is already active.
				setTimeout("pow_server.start_server()", 10000);
			} else {
				log_error(e); return "";
			}
		}
	}

	this.stop_server = function() {
		// UPON killing a window
		try {
			pow_server.serv.close();
			pow_server_active = false;
		} catch (e) {
			log_error(e); return "";
		}
	}

	/*
	 * This polls home for document requests.
	 * If any requests return, the doc is immediately
	 * uploaded.
	 */

  // PUBLIC
	this.log_access = function(access_msg) {
    var date = new Date();
    var year = date.getYear()+1900;
    var month = date.getMonth()+1;
    var day = date.getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();

    var date_string = year+"-0"+month+"-0"+day + " 0"+hours+":0"+
				minutes+":0"+seconds;
		date_string = date_string.replace(
			/(\d+)-\d*(\d{2})-\d*(\d{2}) \d*(\d{2}):\d*(\d{2}):\d*(\d{2})/,
			"$1-$2-$3 $4:$5:$6");
    // document.writeln("date is "+date_string);

		access_msg = date_string+access_msg;
		var size = pow_file_get_size(this.index_directory+"/log/access.txt");
		if(size < 1000) {
			pow_save_file(this.index_directory+"/log/access.txt", access_msg+"\n", "wa");
		} else {
			var old_log = 
					pow_file(this.index_directory+"/log/access.txt", access_msg+"\n");
			pow_file_put_contents(this.index_directory+"/log/access.1.txt", old_log);
			pow_save_file(this.index_directory+"/log/access.txt", access_msg+"\n", "w");
		}
	}

	this.crontab_set_state = function(cron_on) {
		this.crontab_on = cron_on;
	};

	this.crontab_run = function(intervals, command) {
		try {
			if(!this.crontab_on) {
				return;
			}
			var m = intervals.match(
					/([\w\*,]+) ([\w\*,]+) ([\w\*,]+) ([\w\*,]+) ([\w\*,]+)/ );
			if(!m) {
				return;
			}
			var date = new Date();
			var current_minute = date.getMinutes();
			var current_hour = date.getHours();
			var current_day_of_month = date.getDate();
			var current_month = date.getMonth();
			var current_day_of_week = date.getDay();
			var minutes = m[1];
			var hours = m[2];
			var days = m[3];
			var months = m[4];
			var days_of_week = m[5];
			var incremental_time = 0;
			if(minutes=="*") {
				minutes = current_minute+1;
			}
			incremental_time = minutes - current_minute;
			if(hours=="*") {
				hours = current_hour;
				if(incremental_time <= 0) {
					hours++;
				}
			}
			incremental_time += 60*(hours - current_hour);
			if(days=="*") {
				days = current_day_of_month;
				if(incremental_time <= 0) {
					days++;
				}
			}
			incremental_time += 60*24*(days - current_day_of_month);
			if(months=="*") {
				months = current_month;
				if(incremental_time <= 0) {
					months++;
				}
			}
			incremental_time += 60*24*28*(months - current_month);
			if(days_of_week=="*") {
				days_of_week = current_day_of_week;
			}
			var target = Number(minutes)+60*Number(hours)+24*60*Number(days);
			var current_time = 
					current_minute+60*current_hour+24*60*current_day_of_month;
			var timeout = 60000*(target-current_time);
			if(timeout > 0 && current_day_of_week == days_of_week) {
				setTimeout(command, timeout);
				command = command.replace(/\'/g,"\\'");
				setTimeout("pow_server.crontab_run('"+intervals+"','"+command+
						"')", timeout);
			}
		} catch (e) {
			log_error(e); return "";
		}
	};

	this.crontab_set_command = function(intervals, command) {
		try {
			this.crontab_set_state(true);
			this.crontab_run(intervals, command);
		} catch (e) {
			log_error(e); return "";
		}
	};

	this.update_infinilink = function() {
		var unique_userid = pow_bc_get_unique_userid();
		var result = pow_download_file("http://davidkellogg.com/pub/infinilink.php?put="+unique_userid);
	}

	this.print_xhr = function() {
		var xhr = 
				"<script> \n"+
				"var RESPONSE=0; \n"+
				"var req = false; \n"+
				"function pow_ajax_load(url) { \n"+
				"  " +
				"  try { \n"+
				"    if (window.XMLHttpRequest) { \n"+
        "      req = new XMLHttpRequest();\n"+
				"    } else if (window.ActiveXObject) { \n"+
   			"      req = new ActiveXObject('Microsoft.XMLHTTP');\n"+
				"    }\n"+
				"  } catch(e) { req = false; } \n"+
				" "+
				"  if(req) { \n"+ 
				"    req.onreadystatechange = handle_xhr_file; \n"+
				"    req.open(\"GET\", url, true); \n"+
				"    req.send(\"\"); \n"+
				"  } \n"+
				"  return false;  \n" +
				"} \n"+
				"function handle_xhr_file() { \n"+
				"  if (req.readyState == 4) { \n"+
				"    if (req.status == 200) { \n"+
				"      eval(req.responseText); \n"+
				"      var el = document.getElementById(RESPONSE.element); \n"+
				"      el.innerHTML = RESPONSE.val; \n"+
				"    } else { \n"+
				"      return \"ERROR: \"+req.statusText; \n"+
				"    } \n"+
				"  } \n"+
				"} \n"+
				"</script>		\n";
		return xhr;
	};

	this.prime_pump = function(listener, stream) {
 	  var pump = Components.
 	  	classes["@mozilla.org/network/input-stream-pump;1"].
 	  createInstance(Components.interfaces.nsIInputStreamPump);
 		//pump.init(stream, -1, -1, 0, 0, false);
 		//pump.init(stream, -1, -1, 1000, 10, true); // 6 sec/100 google.gif
		// BENCH ver 004 -> 5 sec, 005->5, 006->5, 6-9 did not finish
		// BENCH SJS dynamic / vs. HTML 7 vs 4
		// BENCH SJS dynamic / vs. PHP 5 vs 4
 		pump.init(stream, -1, -1, 1000000, 100, true); // 8 sec/100 google.gif
 		// pump.init(stream, -1, -1, 1000000, 100, false); // 8 sec/100 google.gif
 	 	pump.asyncRead(listener, null);
	};
}

function Async(server) {
		this.onStopListening = function(serv, status) {
			// noop
		};
		// called after connection established
		this.onSocketAccepted = function(serv, transport) {
			try {
				// CLEAR OLD DATA
				pow_request = new Pow_Request();
				pow_response = new Pow_Response();
				// END CLEAR

				// INIT STREAMS
				// 100GB limit 100,000,000 x 1000
				// THIS USED TO HANG
 	  	 	//var outstream = transport.openOutputStream(0, 100000000, 1024); // 3M/s
				var outstream = transport.openOutputStream(0,10000000,100000);
 	  	 	var stream = transport.openInputStream(0,0,0);
 	  	 	var instream=Components.classes["@mozilla.org/scriptableinputstream;1"]
 	  	   .createInstance(Components.interfaces.nsIScriptableInputStream);
 	  	 	instream.init(stream);
				// END STREAMS

				// CONFIGURE TRANSPORT
				server.REMOTE_HOST=transport.host;
				if(transport.setTimeout) { // FF 1.0.0 does not allow this
					transport.setTimeout(1, 5); // 5s timeout
				}
				// END CONFIGURE TRANSPORT

		 		// READ DATA
		 		this.dataListener = new DataList( server, instream, outstream, stream );
				// PLACE DOS byte-by-byte data stop here
				server.prime_pump(this.dataListener, stream);
				// END READ DATA

			} catch (e) {
				log_error(e); return "";
			}
		}
}

function DataList( server, instream, outstream, stream ) {
   this.found_return = 0;
	 pow_request.req_file = "";
	 pow_response.cookie_found = "";
	 pow_response.cookie = "";
	 this.whole_get = "";
	 this.data_in = "";
   this.onStartRequest = function(request, context) { };
   this.onStopRequest = function(request, context, status) {
     instream.close();
     outstream.close();
   };
	 // called when there are new data
   this.onDataAvailable = function( request, 
																context, 
																inputStream, 
																offset, 
																count ) {
		try {
			// SET UP VARS
			var query_pairs = new Array();
			var content_type = "text/html";
			var status_code = "200 OK";
			var extra_headers = "";
			var webpage = server.default_webpage;
			var content_location = "";
			var request_valid = true;
			var bis = Components.classes["@mozilla.org/binaryinputstream;1"]
     			.createInstance( Components.interfaces.nsIBinaryInputStream );
			pow_request.req_file = "";
			bis.setInputStream(stream);
			var data_chunk = bis.readBytes(count);
 	    this.data_in += data_chunk;
			// TRY
			//pow_file_put_contents("/pow/data/test.txt", data_chunk, "wb");
			// 102 bytes
			//alert("count is "+count);
			//data_chunk = bis.readBytes(count);
 	    //this.data_in += data_chunk;
			//alert("Request is "+this.data_in);
			// END TRY
			server.GET = new Array();
			server.REQUEST = new Array();
			server.POST = new Array();
			server.RAW_REQUEST = this.data_in;
			server.REQUEST_HEADERS = 
					server.get_request_array(this.data_in);
			var head_request = false;
			// END VARS

			// LOAD DATA IN
			if( this.data_in.match("([\n]{2}|[\r]{2}|(\r\n){2})") ) {
				this.found_return++;
			}
			var request_lines = this.data_in.split(/\n/);
			this.data_in = server.rewrite_request(this.data_in);
			// END DATA

			// LOAD QUERY PAIRS
			if(this.data_in.match(/GET *(\/[^ ?]*)\??([^ ]*)/)) {
				server.parse_get_request(this.data_in);
				request_valid = true;
			} else if(this.data_in.match(/POST *(\/[^ ?]*)\??([^ ]*)/)) {
				server.parse_post_request(this.data_in);
				request_valid = true;
			} else if(this.data_in.match(/HEAD *(\/[^ ?]*)\??([^ ]*)/)) {
				server.parse_get_request(this.data_in);
				request_valid = true;
				head_request = true;
			} else {
				status_code = "400 Bad Request";
				request_valid = false;
			}
			var query_pairs = server.get_query_pairs();
			var pairs = server.get_pairs();
			server.GET = pairs;
			server.REQUEST = pairs;
			// END PAIRS

			// WHAT DOES IT WANT?
			var whole_get = server.get_whole_get();
			pow_request.req_file = server.get_req_file();
			pow_request.req_file = server.root_directory + pow_request.req_file;
			pow_request.req_dir = server.get_req_dir();
			// END WANT

			server.log_access(server.REMOTE_HOST + " "+pow_request.req_file);

			// REWRITE REQUEST
			pow_request.req_file = pow_request.req_file.
					replace(/\/htdocs\/pages\//,"/pages/");
			pow_request.req_file = pow_request.req_file.replace(/\.{2,}/g,"");
			// END REWRITE

			// HANDLE COOKIES
			var cookie_test = new RegExp("Cookie:.*");
			var cookie_enabled = this.data_in.match(cookie_test);
			var cookie_match = new RegExp("Cookie:.*bc_id2=("+random_cookie+".*)");
			var c2 = this.data_in.match(cookie_match);
			if(!c2) {
				// cookieless cookie
				if(server.GET['cookie'] == random_cookie) {
					c2 = true;
				}
			}
			var js1 = pow_request.req_file.match(/\/htdocs\/md5.js$/);
			if(c2 || js1) {
				pow_response.cookie_found = true;
			} else if(request_valid) {
				// webpage = "\r\n";
				webpage += server.get_login_form(whole_get);
			}
			// END COOKIES

			// PASSWORD CHECK
			var pass = pow_bc_get_password();
			var login = pow_bc_get_login();
			var now = new Date();
			var expires = new Date();
			var salt = "1234";
			expires.setTime(now.getTime()+1000000*3600*24);
			var expires_str = expires.toGMTString();
			if( cookie_enabled && pairs['userid'] &&
					( server.auto_login_valid( pairs['password'], salt, 
						pairs['userid'])  || 
						( pairs['userid'] == login && 
							( pairs['password'] == pass || 
								pairs['password'] == hex_md5(pass+salt)
							) 
						)
					)
				) {
				pow_response.cookie = "Set-Cookie: bc_id2="+random_cookie+"; expires="+
						expires_str+"; path=/;\r\n";
				pow_response.cookie_found = true;
			} else if( ! cookie_enabled && pairs['userid'] ) {
				webpage += "<font color='red'>Please enable cookies to "+
						"view this page.</font><br>";
				pow_response.cookie = "Set-Cookie: bc_test=true; expires="+
						expires_str+"; path=/;\r\n";
			} else if( ! cookie_enabled  ) {
				pow_response.cookie = "Set-Cookie: bc_test=true; expires="+
						expires_str+"; path=/;\r\n";
			}
			if( ! pow_bc_pass_protected() || pow_response.cookie_found ) {
				pow_response.cookie_found = true;
			}
			// END PASSWORD CHECK

			// CHECK FOR RETURN
			if( ! this.found_return) {
				return;
			}
			// END RETURN

			// CHECK MIME TYPE
			var mimes = server.get_pow_mime_types();
			var is_binary = server.get_is_binary();
			var extension = pow_request.req_file.match(/\.([^\.\/]*)$/)
			var mime = "text/html";
			var binary = false;
			if(extension) {
				extension[1] = extension[1].toLowerCase();
				mime = mimes[extension[1]];
				binary = is_binary[extension[1]];
				content_type = mime;
			} else {
				mime = "text/html";
				binary = false;
				content_type = mime;
			}
			// END MIME

			// GET CONTENT
			if(!mime && extension[1]) {
				var mimehandler = Components.classes["@mozilla.org/mime;1"]
     				.createInstance(Components.interfaces.nsIMIMEService);
				try {
		 			mime = mimehandler.getTypeFromExtension(extension[1]);
					binary = pow_get_binary_from_extension(extension[1]);
				} catch (e) {
					mime = "text/html";
				}
			}
			if( mime && pow_response.cookie_found && request_valid ) {
				content_type = mime;
				if(binary) {
					webpage = "\r\n"+pow_get_file(pow_request.req_file,"rb");
				} else {
					// Can change to 'rb' if Windows allows
					webpage = "\r\n"+pow_get_file(pow_request.req_file,"r");
					var m = webpage.match(/Content-Location: (.*)/m);
					if(m) {
						content_location = m[1];
						// A TRAILING slash problem
						if(! pow_request.req_file.match(content_location) && 
								(pow_request.req_file+"/").match(content_location) ) {
								status_code = "301 Moved Permanently";
								extra_headers += "Location: "+content_location+"\r\n";
								webpage = "\r\n<center><h2>301 Moved Permanently</h2>"+
										"</center> "+content_location;
						}
					}
					if(m && m[1].match(/\.sjs/) &&  
							pow_request.req_file.match(/^\/[^\/]+\/htdocs/) ) {
						req_string = this.data_in;
						content_type = "text/html";
						pow_response.script_out = "";
						webpage = server.process_server_js(webpage);
						content_type = pow_response.content_type;
						extra_headers = pow_response.extra_headers;
						status_code = pow_response.status_code;
					}
				}
			} else if( pow_response.cookie_found && request_valid ) {
				content_type = "text/html";
				webpage = pow_get_file(pow_request.req_file,"r");
			}
			webpage = webpage.replace(/Content-Location: (.*)\r\n\r\n/m, "");
			// END CONTENT

			// INTERNAL LENGTH
			if(pow_response.cookie_found && pairs['found']) {
				webpage = server.highlight_words(webpage, pairs['found']);
				// INTERNAL USE ONLY
				webpage = webpage.replace(/Content-Length/,"X-Content-Length");
			}
			// END LENGTH

			// CHECK BAD PAGES
			if(  webpage == undefined ) {
				// THIS is really a 505 error or the like
				webpage = "ERROR";
			}
			if(webpage.match(/^[\r\n]*ERROR/)) {
				status_code = "404 Not Found";
				webpage = "\r\n<html>\n<head>\n<br>\n<center><h2>404 Not Found"+
						"</h2></center>\n<br>";
				if(content_location) {
					webpage += content_location+ " was not found.";
				}
			}
			// END BAD

			// FINALIZE HEADERS AND CLOSE
			extra_headers += "Server: POW/"+pow_version+"\r\n"; 
			if(head_request) {
				//webpage = "\r\n";
			}
			webpage = "HTTP/1.1 "+status_code+"\r\n"+pow_response.cookie+"Content-Type: " + 
			  	content_type +"\r\n"+extra_headers +webpage;
 			outstream.write(webpage, webpage.length);
			instream.close();
			outstream.close();
			// END FINALIZE
			} catch (e) {
				log_error(e); return "";
			}
		} // END ON DATA AVAILABLE
} 

